/0
000 DR,         VAR              000 /Display register (address 0)
001 DR[1],      VAR              000
002 DR[2],      VAR              000
003 DR[3],      VAR              000
004 DR[4],      VAR              000
005 DR[5],      VAR              000
006 DR[6],      VAR              000
007 DR[7],      VAR              000
010 BR,         VAR              000 /Buffer register
011 BR[1],      VAR              000
012 BR[2],      VAR              000
013 BR[3],      VAR              000
014 BR[4],      VAR              000
015 BR[5],      VAR              000
016 BR[6],      VAR              000
017 BRM,        VAR              000 /Buffer register MSB
/1
020 WR,         VAR              000 /Working register
021 WR[1],      VAR              000
022 WR[2],      VAR              000
023 WR[3],      VAR              000
024 WR[4],      VAR              000
025 WR[5],      VAR              000
026 WR[6],      VAR              000
027 WR[7],      VAR              000
030             BLANK            000
031 OP,         VAR              000
032 CTR1,       VAR              000
033 MINUS16,    -16              720
034 START,      CLA.IAC          711
035             DCA OP           311 /OP := 1 (Not a valid OP)
036 CLEARDR,    TAD MINUS16      113
037             DCA CTR1         312 /CTR1 := -16
/2
100             JMP END2         504
101 I2,         VAR              000
102 CTR1A,      A(CTR1)          032
103 FIFTEEN,    15               017
104 END2,       DCA I2           301 /I2 := 0
105 DOCLEARDR,  DCA I I2         321 /DR[I2] := 0
106             INC I2           201 /I2 := I2+1
107             ISZ I CTR1A      222 /CTR1 := CTR1+1; if CTR1 < 0
110             JMP DOCLEARDR    505 /then DOCLEARDR else
111 INITCHAR,   DCA I2           301 /I2 := 0 (DRA)
112             TAD I I2         121 /AC := DR[I2]
113 NEWCHAR,    DCA I I2         321 /DR[I2] := AC
114 DECI2,      CMA              704
115             TAD I2           101
116             AND FIFTEEN      003
117             DCA I2           301 /I2 := (I2-1) mod 16
/3
120             JMP WRITECHAR    505
121 I3,         VAR              000
122 I2A,        A(I2)            101
123 POS,        %01111111        337
124 MINUS122,   -122             406
125 WRITECHAR,  CLA              710
126             TAD I I2A        122
127             DCA I3           301 /I3 := I2
130             TAD I I3         121
131             LDS 0            622 /write(DR[I3])
132             TAD I3           101 /AC := I3
133 TESTCHAR,   SKF 0            601 /if CHARFLAG = 0
134             JMP TESTCHAR     513 /then TESTCHAR else
135             KRB 0            606 /read(AC), FLAG := 0
136             AND POS          003 /clear sign bit of AC
137 LFTEST,     TAD MINUS122     104 /-CTRLLF = -122 = #406
/4
200             SZA              730 /if CHAR <> LF
201             JMP TIMESTEST    512 /then TIMESTEST else
202             JMP I DECI2A     524 /DECI2
203 CTR4,       VAR              000
204 DECI2A,     A(DECI2)         114
205 FOURTEEN,   14               016
206 ENTERTESTA, A(ENTERTEST)     307
207 OPA,        A(OP)            031
210 MINUS8,     -8               730
211             BLANK            000
212 TIMESTEST,  TAD FOURTEEN     105 /CTRLLF-TIMES = 122-108 = 14 = #016
213             SZA              730 /if CHAR <> TIMES
214             JMP I ENTERTESTA 526 /then ENTERTEST else
215 NEWOP,      DCA I OPA        327 /OP := 0
216             TAD MINUS8       110
217             DCA CTR4         303 /CTR4 := -8
/5
220             DCA I5           312 /I5 := 0 (DRA)
221             TAD WRA          114
222             DCA J5           313 /J5 := WRA
223 DOCOPY,     TAD I I5         132
224             DCA I J5         333 /WR[J5] := DR[I5]
225             INC I5           212 /I5 := I5+1
226             INC J5           213 /J5 := J5+1
227             ISZ I CTR4A      235 /CTR4 := CTR4+1; if CTR4 < 0
230             JMP DOCOPY       503 /then DOCOPY else
231             JMP I CLEARDRA   536
232 I5,         VAR              000
233 J5,         VAR              000
234 WRA,        A(WR)            020
235 CTR4A,      A(CTR4)          203
236 CLEARDRA,   A(CLEARDR)       036
237             BLANK            000
/6
300 CTRD,       VAR              000
301 TWO,        2                002
302 CLEARTESTA, A(CLEARTEST)     620
303 OPA,        A(OP)            031
304 WRITECHARA, A(WRITECHAR)     125
305 IDA,        A(ID)            401
306 MINUS8,     -8               730
307 ENTERTEST,  TAD TWO          101 /TIMES-LF = 108-106 = 2
310             SZA              730 /if CHAR <> ENTER
311             JMP I CLEARTESTA 522 /then CLEARTEST else
312             TAD I OPA        123
313 OPTEST,     SZA              730 /if OP <> TIMES
314             JMP I WRITECHARA 524 /then WRITECHAR else
315 TIMES,      DCA I IDA        325 /ID := 0;
316             TAD MINUS8       106
317             DCA CTRD         300 /CTRD := -8;
/7
320             JMP TIMESINIT    511
321 CTRB,       VAR              000
322 CARRY,      VAR              000
323 MINUS8,     -8               730
324 BRA,        A(BR)            010
325 IBA,        A(IB)            427
326 WRA,        A(WR)            020
327 IWA,        A(IW)            402
330             BLANK            000
331 TIMESINIT,  TAD MINUS8       103
332             DCA CTRB         301 /CTRB := -8
333             TAD BRA          104
334             DCA I IBA        325 /IB := A(BR);
335             TAD WRA          106
336             DCA I IWA        327 /IW := A(WR);
337             DCA CARRY        302 /CARRY := 0;
/8
400             JMP MULTINIT     506
401 ID,         VAR              000
402 IW,         VAR              000
403 CARRYB,     VAR              000
404 CTRW,       VAR              000
405 CARRYA,     A(CARRY)         322
406 MULTINIT,   DCA CARRYB       303 /CARRYB := 0;
407             TAD I ID         121
410             CMA.IAC          705
411             SMA              724 /if DR[ID] = 0
412             JMP DIVINIT      517 /then DIVINIT else
413             DCA CTRW         304 /CTRW := -DR[ID], AC := 0
414 MULT,       TAD I IW         122 /AC := AC + WR[IW]
415             ISZ CTRW         204 /CTRW := CTRW+1, if CTRW < 0
416             JMP MULT         514 /then MULT else
417 DIVINIT,    TAD I CARRYA     125
/9
420             TAD I IB         127 /AC := AC + CARRY + BR[IB]
421             CMA.IAC          705 /AC := -AC
422 DIVIDE,     TAD TEN          110
423             SZA.SMA          734 /if SUM-10 > 0
424             JMP DIVEND       513 /then DIVEND else
425 CRYINC,     INC I CARRYBA    231 /CARRYB := CARRYB+1
426             JMP DIVIDE       502
427 IB,         VAR              000
430 TEN,        10               012
431 CARRYBA,    A(CARRYB)        403
432 CARRYA,     A(CARRY)         322
433 DIVEND,     CMA.IAC          705
434             TAD TEN          110
435             DCA I IB         327 /BR[IB] := 10-AC
436             TAD I CARRYBA    131
437             DCA I CARRYA     332 /CARRY := CARRYB
/10
500             JMP END10        510
501 CTRI,       VAR              000
502 IBA,        A(IB)            427
503 IWA,        A(IW)            402
504 CTRBA,      A(CTRB)          321
505 MULTINITA,  A(MULTINIT)      406
506 MINUS7,     -7               731
507 IDA,        A(ID)            401
510 END10,      INC I IBA        222 /IB := IB+1
511             INC I IWA        223 /IW := IW+1
512             ISZ I CTRBA      224 /CTRB := CTRB+1, if CTRB < 0
513             JMP I MULTINITA  525 /then MULTINT else
514             TAD MINUS7       106
515             DCA CTRI         301 /CTRI := -7;
516             TAD I IDA        127
517             INC I IDA        227 /ID := ID+1
/11
520             JMP END11        505
521 I11,        VAR              000
522 IDT,        VAR              000
523 I12,        VAR              000
524 BRA,        A(BR)            010
525 END11,      DCA IDT          302 /IDT := ID-1
526             TAD BRA          104
527             DCA I11          301 /I11 := A(BR)       
530             TAD I I11        121
531             DCA I IDT        322 /DR[IDT] := BR[0]
532             TAD BRA          104
533             IAC              701
534             DCA I12          303 /I12 := A(BR)+1
535 MOVE,       TAD I I12        123
536             DCA I I11        321 /BR[I11] := BR[I12]
537             INC I11          201 /I11 := I11+1
/12
600             INC I I12A       230 /I12 := I12+1
601             ISZ I CTRIA      231 /CTRI := CTRI+1, if CTRI < 0
602             JMP I MOVEA      532 /then MOVE else
603             TAD I CARRYA     133
604             DCA I BRMA       334 /BRM := CARRY
605             ISZ I CTRDA      235 /CTRD := CTRD+1, if CTRD < 0
606             JMP I TIMESINITA 536 /the TIMESINIT else
607             JMP I INITCHARA  537 /INITCHAR
610 I12A,       A(I12)           523
611 CTRIA,      A(CTRI)          501
612 MOVEA,      A(MOVE)          535
613 CARRYA,     A(CARRY)         322
614 BRMA,       A(BRM)           017
615 CTRDA,      A(CTRD)          300
616 TIMESINITA, A(TIMESINIT)     331
617 INITCHARA,  A(INITCHAR)      111
/13
620 CLEARTEST,  TAD PLUS90       110 /LF-CTRL0 = 106-16 = 90 = #232
621             SZA              730 /if CHAR <> CTRL(0)
622             JMP NUMTEST      504 /then ENTERTEST else
623             JMP I CLEARDRA   531 /CLEARDR
624 NUMTEST,    SMA              724 /if 0 > AC > 9
625             JMP I WRITECHARA 532 /then WRITECHAR else
626             TAD CTRL0        113 /AC := AC+CTRL0
627             JMP I NEWCHARA   534 /NEWCHAR
630 PLUS90,     90               232
631 CLEARDRA,   A(CLEARDR)       036
632 WRITECHARA, A(WRITECHAR)     125
633 CTRL0,      16               020
634 NEWCHARA,   A(NEWCHAR)       113
