/0
000 DR,         VAR              000 /Display register (address 0)
001 DR[1],      VAR              000
002 DR[2],      VAR              000
003 DR[3],      VAR              000
004 DR[4],      VAR              000
005 DR[5],      VAR              000
006 DRM,        VAR              000 /Display register MSBs
007 DRM[1],     VAR              000
010 BR,         VAR              000 /Buffer register
011 BR[1],      VAR              000
012 BR[2],      VAR              000
013 BR[3],      VAR              000
014 BR[4],      VAR              000
015 BR[5],      VAR              000
016 BR[6],      VAR              000
017 BR[7],      VAR              000
/1
020 WR,         VAR              000 /Working register
021 WR[1],      VAR              000
022 WR[2],      VAR              000
023 WR[3],      VAR              000
024 WR[4],      VAR              000
025 WR[5],      VAR              000
026 WR[6],      VAR              000
027 WRM,        VAR              000 /Working register MSB
030             BLANK            000
031 OP,         VAR              000
032 CTR1,       VAR              000
033 MINUS16,    -16              720
034 START,      CLA.IAC          711
035             DCA OP           311 /OP := 1 (Not a valid OP)
036 CLEARDR,    TAD MINUS16      113
037             DCA CTR1         312 /CTR1 := -16
/2
100             JMP END2         504
101 I2,         VAR              000
102 CTR1A,      A(CTR1)          032
103 FIFTEEN,    15               017
104 END2,       DCA I2           301 /I2 := 0
105 DOCLEARDR,  DCA I I2         321 /DR[I2] := 0
106             INC I2           201 /I2 := I2+1
107             ISZ I CTR1A      222 /CTR1 := CTR1+1; if CTR1 < 0
110             JMP DOCLEARDR    505 /then DOCLEARDR else
111 INITCHAR,   DCA I2           301 /I2 := 0 (DRA)
112             TAD I I2         121 /AC := DR[I2]
113 NEWCHAR,    DCA I I2         321 /DR[I2] := AC
114 DECI2,      CLA.CMA          714
115             TAD I2           101
116             AND FIFTEEN      003
117             DCA I2           301 /I2 := (I2-1) mod 16
/3
120             JMP WRITECHAR    505
121 I3,         VAR              000
122 I2A,        A(I2)            101
123 POS,        %01111111        337
124 MINUS122,   -122             406
125 WRITECHAR,  CLA              710
126             TAD I I2A        122
127             DCA I3           301 /I3 := I2
130             TAD I I3         121
131             LDS 0            622 /write(DR[I3])
132             TAD I3           101 /AC := I3
133 TESTCHAR,   SKF 0            601 /if CHARFLAG = 0
134             JMP TESTCHAR     513 /then TESTCHAR else
135             KRB 0            606 /read(AC), FLAG := 0
136             AND POS          003 /clear sign bit of AC
137 LFTEST,     TAD MINUS122     104 /-CTRLLF = -122 = #406
/4
200             SZA              730 /if CHAR <> LF
201             JMP DIVTEST      512 /then DIVTEST else
202             JMP I DECI2A     523 /DECI2
203 DECI2A,     A(DECI2)         114
204 TWELVE,     12               014
205 ENTERTESTA, A(ENTERTEST)     235
206 OPA,        A(OP)            031
207 IMA,        A(IM)            520
210 WRA,        A(WR)            020
211             BLANK            000
212 DIVTEST,    TAD TWELVE       104 /CTRLLF-DIVIDE = 122-110 = 12 = #014
213             SZA              730 /if CHAR <> DIVIDE
214             JMP I ENTERTESTA 525 /then ENTERTEST else
215 NEWOP,      DCA I OPA        326 /OP := 0
216             DCA I IMA        327 /IM := 0 (DRA)
217             TAD WRA          110
/5
220             DCA I JMA        323 /JM := WRA
221             JMS I COPYA      424 /WR := DR
222             JMP I CLEARDRA   525
223 JMA,        A(JM)            521
224 COPYA,      A(COPY)          525
225 CLEARDRA,   A(CLEARDR)       036
226 PLUS90,     90               232
227 NUMTESTA,   A(NUMTEST)       724
230 FOUR,       4                004
231 CLEARTEST,  TAD PLUS90       106 /LF-CTRL0 = 106-16 = 90 = #232
232             SZA              730 /if CHAR <> CTRL(0)
233             JMP I NUMTESTA   527 /then ENTERTEST else
234             JMP I CLEARDRA   525 /CLEARDR
235 ENTERTEST,  TAD FOUR         110 /DIVIDE-LF = 110-106 = 4
236             SZA              730 /if CHAR <> ENTER
237             JMP CLEARTEST    511 /then CLEARTEST else
/6
300             JMP END6         510
301 CTRW,       VAR              000
302 OPA,        A(OP)            031
303 WRITECHARA, A(WRITECHAR)     125
304 MINUS8,     -8               730
305 WRMA,       A(WRM)           027
306 IWA,        A(IW)            404
307 NEGA,       A(NEG)           633
310 END6,       TAD I OPA        122
311 OPTEST,     SZA              730 /if OP <> DIVIDE
312             JMP I WRITECHARA 523 /then WRITECHAR else
313 DIVIDE,     TAD MINUS8       104
314             DCA CTRW         301 /CTRW := -8
315             TAD WRMA         105 /AC := A(WRM)
316 DIVINIT,    DCA I IWA        326 /IW := AC
317             JMS I NEGA       427 /DR := -DR
/7
320             JMP END7         505
321 CTR7,       VAR              000
322 DRMA,       A(DRM)           006
323 EIGHT,      8                010
324 MINUS10,    -10              726
325 END7,       TAD DRMA         102 /AC := A(DRM)
326 SHIFT,      TAD EIGHT        103 /AC := AC+8
327             DCA CTR7         301 /CTR7 := AC
330             TAD I CTR7       121 /AC := BR[CTR7]
331             INC CTR7         201 /CTR7 := CTR7+1
332             DCA I CTR7       321 /BR[CTR7] := AC
333             TAD CTR7         101
334             TAD MINUS10      104 /AC := CTR7-10
335             SMA              724 /if AC >= 0
336             JMP SHIFT        506 /then SHIFT else
337             CLA              710
/8
400             TAD I IW         124
401             DCA I BRA        326 /BR[0] := WR[IW]
402             DCA I IW         324 /WR[IW] := 0
403             JMP DODIVST      512
404 IW,         VAR              000
405 CARRY,      VAR              000
406 BRA,        A(BR)            010
407 ADDA,       A(ADD)           617
410 NEGA,       A(NEG)           633
411 DODIV,      INC I IW         224 /WR[IW] := WR[IW]+1
412 DODIVST,    JMS I ADDA       427 /BR := BR+DR
413             TAD CARRY        105
414             SZA              730 /if CARRY = 1
415             JMP DODIV        511 /then DODIV else
416             JMS I NEGA       430 /DR := -DR
417             JMS I ADDA       427 /BR := BR+DR
/9
420             CLA.CMA          714
421             TAD I IWA        131 /AC := IW-1
422             ISZ I CTRWA      232 /CTRW := CTRW+1, if CTRW < 0
423             JMP I DIVINITA   533 /then DIVINIT else
424             IAC              701
425             DCA I IMA        334 /IM := A(WR)
426             DCA I JMA        335 /JM := 0 (DRA)
427             JMS I COPYA      436 /DR := WR
430             JMP I INITCHARA  537 /INITCHAR
431 IWA,        A(IW)            404
432 CTRWA,      A(CTRW)          301
433 DIVINITA,   A(DIVINIT)       316
434 IMA,        A(IM)            520
435 JMA,        A(JM)            521
436 COPYA,      A(COPY)          525
437 INITCHARA,  A(INITCHAR)      111
/10
500 TEMP,       VAR              000
501 CARRYA,     A(CARRY)         405
502 MINUS10,    -10              726
503 CARRYADD,   RTNADR           000 /AC:=(AC+CARRY) mod 10, CARRY:=(AC+CARRY) div 10
504             TAD I CARRYA     121
505             DCA TEMP         300 /TEMP := AC+CARRY
506             IAC              701
507             DCA I CARRYA     321 /CARRY := 1
510             TAD TEMP         100
511             TAD MINUS10      102 /AC := TEMP-10
512             SMA              724 /if TEMP-10 >= 0
513             JMP I CARRYADD   523 /then RETURN else
514             CLA              710
515             DCA I CARRYA     321 /CARRY := 0
516             TAD TEMP         100
517             JMP I CARRYADD   523 /RETURN
/11
520 IM,         VAR              000
521 JM,         VAR              000
522 CTRM,       VAR              000
523 MINUS8,     -8               730
524 BRA,        A(BR)            010
525 COPY,       RTNADR           000
526             TAD MINUS8       103
527             DCA CTRM         302 /CTRM := -8
530 DOCOPY,     TAD I IM         120
531             DCA I JM         321 /R[JM] := R[IM]
532             INC IM           200 /IM := IM+1
533             INC JM           201 /JM := JM+1
534             ISZ CTRM         202 /CTRM := CTRM+1; if CTRM < 0
535             JMP DOCOPY       510 /then DOCOPY else
536 COPYRTN,    JMP I COPY       525
537 ADDCONT,    TAD BRA          104
/12
600             DCA JA           314 /JA := A(BR)
601             DCA IA           313 /IA := 0 (DRA)
602 DOADD,      TAD I IA         133
603             TAD I JA         134
604             JMS I CARRYADDA  436
605             DCA I JA         334 /BR[JA] := (BR[JA]+DR[IA]+CARRY) mod 10
606             INC IA           213 /IA := IA+1
607             INC JA           214 /JA := JA+1
610             ISZ CTRA         215 /CTRA := CTRA+1, if CTRA < 0
611             JMP DOADD        502 /then DOADD else
612 ADDRTN,     JMP I ADD        537
613 IA,         VAR              000
614 JA,         VAR              000
615 CTRA,       VAR              000
616 CARRYADDA,  A(CARRYADD)      503
617 ADD,        RTNADR           000
/13
620             CLA              710
621             DCA I CARRYA     326 /CARRY := 0
622             TAD MINUS8       107
623             DCA I CTRAA      330 /CTRA := -8
624             JMP I ADDCONTA   531
625 CTRN,       VAR              000
626 CARRYA,     A(CARRY)         405
627 MINUS8,     -8               730
630 CTRAA,      A(CTRA)          615
631 ADDCONTA,   A(ADDCONT)       537
632 NEGRTN,     JMP I NEG        533
633 NEG,        RTNADR           000
634             CLA.IAC          711
635             DCA I CARRYA     326 /CARRY := 1
636             TAD MINUS8       107
637             DCA CTRN         305 /CTRN := -8;
/14
700             JMP END14        506
701 IN,         VAR              000
702 NINE,       9                011
703 CARRYADDA,  A(CARRYADD)      503
704 CTRNA,      A(CTRN)          625
705 CARRYA,     A(CARRY)         405
706 END14,      DCA IN           301 /IN := 0 (DRA)
707 DONEG,      TAD I IN         121
710             CMA.IAC          705
711             TAD NINE         102 /AC := 9-DR[IN]
712             JMS I CARRYADDA  423
713             DCA I IN         321 /DR[IN] := (AC+CARRY) mod 10
714             INC IN           201 /IN := IN+1
715             ISZ I CTRNA      224 /CTRN := CTRN+1, if CTRN < 0
716             JMP DONEG        507 /then DONEG else
717             TAD I CARRYA     125
/15
720             CMA.IAC          705
721             SMA              724 /if CARRY = 0
722             JMP I NEGRTNA    530 /then NEGRTN else
723             JMP I STARTA     531 /START
724 NUMTEST,    SMA              724 /if 0 > AC > 9
725             JMP I WRITECHARA 532 /then WRITECHAR else
726             TAD CTRL0        113 /AC := AC+CTRL0
727             JMP I NEWCHARA   534 /NEWCHAR
730 NEGRTNA,    A(NEGRTN)        632
731 STARTA,     A(START)         034
732 WRITECHARA, A(WRITECHAR)     125
733 CTRL0,      16               020
734 NEWCHARA,   A(NEWCHAR)       113
